commit 86012c14adc75d7fe11037f9efdf12d6c7ace445
Author: stepanekp <1stepanekpetr@gmail.com>
Date:   Sun Apr 21 09:58:46 2024 +0200

    table names added

diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/app/User.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/app/User.java
index 50957f6..798e2f7 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/app/User.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/app/User.java
@@ -8,7 +8,7 @@ import javax.persistence.*;
  * @author Vaclav Hrabik, Jiri Trefil
  */
 @Entity
-@Table(name = "Users")
+@Table(name = "users")
 public class User {
 
     /**
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/Project.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/Project.java
index 0a78f85..aaf2365 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/Project.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/Project.java
@@ -12,6 +12,7 @@ import java.util.Set;
  * Model class for project. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "project")
 public class Project {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Activity.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Activity.java
index 8280a81..360546c 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Activity.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Activity.java
@@ -13,6 +13,7 @@ import java.util.List;
  * Model class for category. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "activity")
 public class Activity implements DatabaseObject {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Branch.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Branch.java
index 5663b82..98d1316 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Branch.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Branch.java
@@ -8,6 +8,7 @@ import java.util.Set;
  * Model class for branches. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "branch")
 public class Branch {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Category.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Category.java
index e483fa3..fa5c007 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Category.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Category.java
@@ -10,6 +10,7 @@ import java.util.Set;
  * Model class for category. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "category")
 public class Category implements DatabaseObject {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Commit.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Commit.java
index 30c6b9a..a5eacc5 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Commit.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Commit.java
@@ -8,6 +8,7 @@ import java.util.Set;
  * Model class for commit. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "commit")
 public class Commit {
 
     @OneToOne
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Configuration.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Configuration.java
index 468853f..0fb29f7 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Configuration.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Configuration.java
@@ -8,6 +8,7 @@ import javax.persistence.*;
  * Model class for configurations. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "configuration")
 public class Configuration {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/ConfigurationPersonRelation.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/ConfigurationPersonRelation.java
index bfdb1b7..2d4c83d 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/ConfigurationPersonRelation.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/ConfigurationPersonRelation.java
@@ -6,6 +6,7 @@ import javax.persistence.*;
  * Model class for configuration person relation. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "configuration_person_relation")
 public class ConfigurationPersonRelation {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Identity.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Identity.java
index 19e3419..1edceb2 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Identity.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Identity.java
@@ -8,6 +8,7 @@ import javax.persistence.*;
  * Model class for identities. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "identity")
 public class Identity implements DatabaseObject {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Iteration.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Iteration.java
index b0e757b..053914d 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Iteration.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Iteration.java
@@ -13,6 +13,7 @@ import java.util.List;
  * Model class for iteration. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "iteration")
 public class Iteration implements DatabaseObject {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Person.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Person.java
index 4f378df..c8c573e 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Person.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Person.java
@@ -13,6 +13,7 @@ import java.util.Set;
  * Model class for people. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "person")
 public class Person implements DatabaseObject {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Phase.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Phase.java
index abe537b..e045c96 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Phase.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Phase.java
@@ -13,6 +13,7 @@ import java.util.List;
  * Model class for phases. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "phase")
 public class Phase implements DatabaseObject {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Tag.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Tag.java
index d542aa3..17dd6aa 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Tag.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/Tag.java
@@ -6,6 +6,7 @@ import javax.persistence.*;
  * Model class for tags. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "tag")
 public class Tag {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Priority.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Priority.java
index 1ddd158..c9ef6fb 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Priority.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Priority.java
@@ -10,6 +10,7 @@ import javax.persistence.*;
  * Model class for priority. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "priority")
 public class Priority implements EnumType {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/PriorityClassification.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/PriorityClassification.java
index d91c74c..866ec42 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/PriorityClassification.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/PriorityClassification.java
@@ -10,6 +10,7 @@ import java.util.List;
  * Model class for priority classes. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "priority_classification")
 public class PriorityClassification implements Classification {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Relation.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Relation.java
index 52240b9..a488488 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Relation.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Relation.java
@@ -10,6 +10,7 @@ import javax.persistence.*;
  * Model class for relations. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "relation")
 public class Relation implements EnumType {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RelationClassification.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RelationClassification.java
index 80721fe..9aeb6b3 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RelationClassification.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RelationClassification.java
@@ -10,6 +10,7 @@ import java.util.List;
  * Model class for relation classes. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "relation_classification")
 public class RelationClassification implements Classification {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Resolution.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Resolution.java
index d7298e8..a548c7a 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Resolution.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Resolution.java
@@ -10,6 +10,7 @@ import javax.persistence.*;
  * Model class for resolution. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "resolution")
 public class Resolution implements EnumType {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/ResolutionClassification.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/ResolutionClassification.java
index 8ecf164..0e9e51c 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/ResolutionClassification.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/ResolutionClassification.java
@@ -10,6 +10,7 @@ import java.util.List;
  * Model class for resolution classes. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "resolution_classification")
 public class ResolutionClassification implements Classification {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Role.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Role.java
index 9cc56e5..f1eabf9 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Role.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Role.java
@@ -11,6 +11,7 @@ import javax.persistence.*;
  * Model class for role. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "role")
 public class Role implements EnumType {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RoleClassification.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RoleClassification.java
index 05efa00..00884e4 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RoleClassification.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/RoleClassification.java
@@ -10,6 +10,7 @@ import java.util.List;
  * Model class for role classes. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "role_classification")
 public class RoleClassification implements Classification {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Severity.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Severity.java
index 1b86196..d19abf1 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Severity.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Severity.java
@@ -10,6 +10,7 @@ import javax.persistence.*;
  * Model class for severity. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "severity")
 public class Severity implements EnumType {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/SeverityClassification.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/SeverityClassification.java
index 7766d18..2a07d41 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/SeverityClassification.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/SeverityClassification.java
@@ -10,6 +10,7 @@ import java.util.List;
  * Model class for severity classes. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "severity_classification")
 public class SeverityClassification implements Classification {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Status.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Status.java
index fe81ed9..518a3e9 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Status.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/Status.java
@@ -10,6 +10,7 @@ import javax.persistence.*;
  * Model class for statuses. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "status")
 public class Status implements EnumType {
 
     @Id
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/StatusClassification.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/StatusClassification.java
index 7789ba9..2e5e123 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/StatusClassification.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/model/project/management/enums/StatusClassification.java
@@ -10,6 +10,7 @@ import java.util.List;
  * Model class for status classes. This is Entity class that is loaded from db.
  */
 @Entity
+@Table(name = "status_classification")
 public class StatusClassification implements Classification {
 
     @Id