commit 8a1fe4e5937c3dd3b5acefa55281476c24eb86ca
Author: Ondřej Váně <onry.vane@gmail.com>
Date:   Thu Apr 15 22:14:53 2021 +0200

    Extract all settings as constants

diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/BusinessAsUsualDetectorImpl.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/BusinessAsUsualDetectorImpl.java
index 036423d..e8fe401 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/BusinessAsUsualDetectorImpl.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/BusinessAsUsualDetectorImpl.java
@@ -29,7 +29,7 @@ public class BusinessAsUsualDetectorImpl extends AntiPatternDetector {
     private List<String> sqlQueries;
 
     /**
-     * Settings
+     * SETTINGS
      */
     private final float DIVISION_BUSINESS_AS_USUAL_ITERATIONS = (float) 1/3;
 
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/LongOrNonExistentFeedbackLoopsDetectorImpl.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/LongOrNonExistentFeedbackLoopsDetectorImpl.java
index 5ae22aa..50baf58 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/LongOrNonExistentFeedbackLoopsDetectorImpl.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/LongOrNonExistentFeedbackLoopsDetectorImpl.java
@@ -33,13 +33,8 @@ public class LongOrNonExistentFeedbackLoopsDetectorImpl extends AntiPatternDetec
     private List<String> sqlQueries;
 
     /**
-     * Settings
+     * SETTINGS
      */
-    private final float DIVISION_LONG_OR_NON_FEEDBACK_ITERATIONS = (float) 1 / 3;
-
-    /* Settings */
-    private final int MINIMUM_NUMBER_OF_WIKI_PAGES = 1;
-    private final int MINIMUM_NUMBER_OF_ACTIVITIES = 1;
 
     @Override
     public AntiPattern getAntiPatternModel() {
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/NinetyNinetyRuleDetectorImpl.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/NinetyNinetyRuleDetectorImpl.java
index 7d41ffb..82e84c6 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/NinetyNinetyRuleDetectorImpl.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/NinetyNinetyRuleDetectorImpl.java
@@ -24,6 +24,10 @@ public class NinetyNinetyRuleDetectorImpl extends AntiPatternDetector {
     // sql queries loaded from sql file
     private List<String> sqlQueries;
 
+    /**
+     * SETTINGS
+     */
+
     @Override
     public AntiPattern getAntiPatternModel() {
         return this.antiPattern;
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/RoadToNowhereDetectorImpl.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/RoadToNowhereDetectorImpl.java
index 68b520f..9e8be76 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/RoadToNowhereDetectorImpl.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/RoadToNowhereDetectorImpl.java
@@ -28,7 +28,9 @@ public class RoadToNowhereDetectorImpl extends AntiPatternDetector {
     // sql queries loaded from sql file
     private List<String> sqlQueries;
 
-    /* Settings */
+    /**
+     * SETTINGS
+     */
     private final int MINIMUM_NUMBER_OF_WIKI_PAGES = 1;
     private final int MINIMUM_NUMBER_OF_ACTIVITIES = 1;
 
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/SpecifyNothingDetectorImpl.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/SpecifyNothingDetectorImpl.java
index 325b441..ba6059a 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/SpecifyNothingDetectorImpl.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/SpecifyNothingDetectorImpl.java
@@ -27,7 +27,9 @@ public class SpecifyNothingDetectorImpl extends AntiPatternDetector {
     // sql queries loaded from sql file
     private List<String> sqlQueries;
 
-    /* Settings */
+    /**
+     * SETTINGS
+     */
     private final int MINIMUM_NUMBER_OF_WIKI_PAGES = 1;
     private final int MINIMUM_NUMBER_OF_ACTIVITIES = 1;
     private final double MINIMUM_AVERAGE_LENGTH_OF_ACTIVITY_DESCRIPTION = 150;
diff --git a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/TooLongSprintDetectorImpl.java b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/TooLongSprintDetectorImpl.java
index db8f357..2662b26 100644
--- a/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/TooLongSprintDetectorImpl.java
+++ b/src/main/java/cz/zcu/fav/kiv/antipatterndetectionapp/detecting/detectors/TooLongSprintDetectorImpl.java
@@ -30,7 +30,10 @@ public class TooLongSprintDetectorImpl extends AntiPatternDetector {
     // sql queries loaded from sql file
     private List<String> sqlQueries;
 
-    // TODO vytáhnout konstanty ZDE
+    /**
+     * SETTINGS
+     */
+    private static final int MAX_NUMBER_OF_TOO_LONG_ITERATIONS = 1;
 
 
     @Override
@@ -89,7 +92,7 @@ public class TooLongSprintDetectorImpl extends AntiPatternDetector {
         List<ResultDetail> resultDetails = new ArrayList<>();
         resultDetails.add(new ResultDetail("Count of iterations", String.valueOf(totalCountOfIteration)));
         resultDetails.add(new ResultDetail("Number of too long iterations", String.valueOf(numberOfLongIterations)));
-        if (numberOfLongIterations >= 1) {
+        if (numberOfLongIterations >= MAX_NUMBER_OF_TOO_LONG_ITERATIONS) {
             resultDetails.add(new ResultDetail("Conclusion", "One or more iteration is too long"));
         } else {
             resultDetails.add(new ResultDetail("Conclusion", "All iterations in limit"));